package de.dfki.km.academicresearch.eswc2016challenge;

import de.dfki.km.academicresearch.eswc2016challenge.data.Path;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jade.GraphIndexJade;
import de.dfki.km.academicresearch.eswc2016challenge.sink.ArraySink;
import de.dfki.km.academicresearch.eswc2016challenge.sink.BulkJadeSink;
import de.dfki.km.academicresearch.eswc2016challenge.sink.SQLiteSink;
import de.dfki.km.academicresearch.eswc2016challenge.sink.StreamJadeSink;
import de.dfki.km.academicresearch.eswc2016challenge.util.Util;
import java.io.File;
import java.util.List;
import org.apache.jena.atlas.lib.Sink;
import org.apache.jena.graph.Triple;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.Statement;
import org.apache.jena.riot.RDFDataMgr;
import org.apache.jena.riot.system.StreamRDF;
import org.apache.jena.riot.system.StreamRDFLib;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@Deprecated
public class Main {

    private static final Logger logger = LoggerFactory.getLogger(Main.class);

    
    
    
    
    
    
    
    
    
    //OLD CODE - clean up after code transfere:
    
    public static void main(String[] args) throws Exception {
    	/*
    	File f = new File("./challenge_training_result_sets/task1_q1_344.txt");
    	List<Path> expected = Util.getPaths(f);
    	for(Path p : expected){
    		logger.debug(""+p.getPath().size());
    	}
    	*/
    	
    	File f = new File("./challenge_training_result_sets/task1_q4_250.txt");
    	List<Path> expected = Util.getPaths(f);
    	List<Path> allequalWeight = expected.subList(0, 2);
    	for(Path p : allequalWeight){
    		logger.debug(""+p.getPath().size());
    	}

        /*
         * PREFIX dbc: <http://dbpedia.org/resource/Category:>
         * PREFIX dbo: <http://dbpedia.org/ontology/>
         * PREFIX dbp: <http://dbpedia.org/property/>
         * PREFIX dbr: <http://dbpedia.org/resource/>
         */
        /*
         String strQuery = "PREFIX dbr: <http://dbpedia.org/resource/>\r\n" + 
         "PREFIX : <http://doesnotexist.org>\r\n" + 
         "SELECT *\r\n" + 
         "WHERE  { dbr:Felipe_Massa !:* dbr:Red_Bull }";
	
         Query query = QueryFactory.create(strQuery) ;
         Op op = Algebra.compile(query) ;
         logger.info("Parsed query: {}", op);
		
         Op optimized = Algebra.optimize(op);
         logger.info("Optimised query: {}", optimized);
         */
        
        //createDatasetTraining();

		//System.out.println(query.serialize()) ;		
        //IndentedWriter w = new IndentedWriter(System.out);		
        //op.output(w);
        //createDatasetTraining();
        //createDatasetTraining();
        /*
         HiconEngine.register();
		
         List<QueryEngineFactory> possibleFactories = QueryEngineRegistry.get().factories();
		
		
         Model m = createModel();
		
		
         QueryExecution qe = QueryExecutionFactory.create(query, m);//QueryExecutionFactory.create(query, infmodel);
         ResultSet response =  qe.execSelect();
         qe.close();

	    
	    
         //DatasetGraphTDB
	    
         QueryExecutionBase qeb;
	    
         QueryEngineMain main;
		
         //Query query = OpAsQuery.asQuery(op) ;
         //System.out.println(query.serialize()) ;
         */
        
        //main6();
    }

    /*
    private static void main6() throws Exception {
        JadeLoader l2 = new JadeLoader("challenge_training_dataset/vs_es.javaser"); 
        
        GraphIndexJade jade = l2.loadJade();//deserialization Total time: 15.105s
        
        JadePathFinder pathFinderJade = new JadePathFinder(jade);
        List<Path> pathes = pathFinderJade.find("http://dbpedia.org/resource/Felipe_Massa", "http://dbpedia.org/resource/Red_Bull", 8, null);
        
        for(Path path : pathes) {
            logger.debug(path.toString());
        }
    }
    */
    
    private static void main5() throws Exception {
        
        Sink<Triple> sink = new SQLiteSink("training_dataset_filtered.db");
        StreamRDF streamRDF = StreamRDFLib.sinkTriples(sink);
        
        logger.debug("start");
        
        RDFDataMgr.parse(streamRDF, "training_dataset_filtered.nt");
        
        logger.debug("end");
        
        sink.close();
    }
    
    private static void main3() throws Exception {
        //10.000.000 triple * 3
        Sink<Triple> sink = new ArraySink(30000000);
        StreamRDF streamRDF = StreamRDFLib.sinkTriples(sink);
        
        logger.debug("start");
        
        RDFDataMgr.parse(streamRDF, "training_dataset_filtered.nt"); //Total time: 1:37.099s (only load)
        
        logger.debug("end");
        
        sink.close();
    }
    
    /*
    private static void main2() throws Exception {
        Model m = createDatasetD1();
        
        GraphIndexJade jade = new GraphIndexJade();
        StreamJadeSink mysink = new StreamJadeSink(jade);
        StreamRDF dst = StreamRDFLib.sinkTriples(new StreamJadeSink(jade));
        
        transfer(m, dst);
        
        JadePathFinder pathFinderJade = new JadePathFinder(jade);
        List<Path> pathes = pathFinderJade.find(dfkiPrefix + "A", dfkiPrefix + "B", 4, null);
        
        for(Path path : pathes) {
            logger.debug(path.toString());
        }
    }
    */
    
    

    public static Model createDatasetTraining() {
        
        GraphIndexJade jade = new GraphIndexJade();
        StreamJadeSink mysink = new StreamJadeSink(jade);
        StreamRDF dst = StreamRDFLib.sinkTriples(new BulkJadeSink(jade));
        
        RDFDataMgr.parse(dst, "training_dataset_filtered.nt"); 
       
        return null;
    }

    public static void transfer(Model model, StreamRDF streamRDF) {
        streamRDF.start();
        for(Statement stmt : model.listStatements().toSet()) {
            streamRDF.triple(stmt.asTriple());
        }
        streamRDF.finish();
    }
    
    

}
