package de.dfki.km.academicresearch.eswc2016challenge.pathfinder;

import java.util.List;

import org.apache.commons.collections15.Transformer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.dfki.km.academicresearch.eswc2016challenge.data.Path;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.basis.URIPathFinder;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jung.Eppstein;
import edu.uci.ics.jung.graph.DirectedSparseMultigraph;
import edu.uci.ics.jung.graph.Graph;

public class JungPathFinder extends URIPathFinder {
	
	private static final Logger logger = LoggerFactory.getLogger(JungPathFinder.class);

	private Graph<String, String> g;
	private Eppstein<String, String> epp;
	
	@Override
	public List<Path> find(String srcURI, String dstURI, int k, String startOrEndProp) throws Exception {
		
		List<List<String>> path = epp.getShortestPaths(srcURI, dstURI, k);
		
		
		logger.debug(path.toString());
		
		return null;
	}
	
	
	
	@Override
	public void sendOnlyURI(String subject, String predicate, String object) {		
		g.addEdge(predicate, subject, object);		
	}
	
	@Override
	public void startStreaming() throws Exception {
		g = new DirectedSparseMultigraph();
	}
	
	@Override
	public void endStreaming() throws Exception {
		
		epp = new Eppstein<String, String>(g, tranformToOne);	
		
	}
	
	
	Transformer<String, Number> tranformToOne = new Transformer<String, Number>() {
		@Override
		public Number transform(String arg0) {
			return 1;
		}		 
	};
}
