package de.dfki.km.academicresearch.eswc2016challenge.pathfinder;

import java.io.File;
import java.util.List;

import org.apache.jena.graph.Triple;
import org.neo4j.graphdb.GraphDatabaseService;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Relationship;
import org.neo4j.graphdb.RelationshipType;
import org.neo4j.graphdb.Transaction;
import org.neo4j.graphdb.factory.GraphDatabaseFactory;
import org.neo4j.graphdb.factory.GraphDatabaseSettings;

import de.dfki.km.academicresearch.eswc2016challenge.data.Path;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.basis.PathFinder;


//http://neo4j.com/docs/stable/tutorials-java-embedded-hello-world.html

//https://groups.google.com/forum/#!topic/nosql-databases/lXnBX3tg1NY
//http://stackoverflow.com/questions/22637194/neo4j-k-shortest-paths-with-cost-property

//allshortestpath
//http://neo4j.com/docs/milestone/query-match.html

public class Neo4jPathFinder extends PathFinder {

	private static enum RelTypes implements RelationshipType
	{
	    KNOWS
	}
	
	public Neo4jPathFinder() {
		
		GraphDatabaseService graphDb = new GraphDatabaseFactory().newEmbeddedDatabase( new File("./neo4j.txt") );
		
		//new GraphDatabaseFactory().newEmbeddedDatabaseBuilder( new File("./neo4j.txt") )
	    //.setConfig( GraphDatabaseSettings.pagecache_memory, "512M" )
	    //.setConfig( GraphDatabaseSettings.string_block_size, "60" )
	    //.setConfig( GraphDatabaseSettings.array_block_size, "300" )
	    //.newGraphDatabase();
		
		registerShutdownHook( graphDb );
		
		
		
		try ( Transaction tx = graphDb.beginTx() )
		{
			Node firstNode;
			Node secondNode;
			Relationship relationship;
			
			firstNode = graphDb.createNode();
			firstNode.setProperty( "message", "Hello, " );
			secondNode = graphDb.createNode();
			secondNode.setProperty( "message", "World!" );

			relationship = firstNode.createRelationshipTo( secondNode, RelTypes.KNOWS );
			relationship.setProperty( "message", "brave Neo4j " );
			
			
		    tx.success();
		}
		
		
		
		graphDb.shutdown();
		
	}
	
	private static void registerShutdownHook( final GraphDatabaseService graphDb )
	{
	    // Registers a shutdown hook for the Neo4j instance so that it
	    // shuts down nicely when the VM exits (even if you "Ctrl-C" the
	    // running application).
	    Runtime.getRuntime().addShutdownHook( new Thread()
	    {
	        @Override
	        public void run()
	        {
	            graphDb.shutdown();
	        }
	    } );
	}
	
	
	@Override
	public List<Path> find(String srcURI, String dstURI, int k, String startOrEndProp) throws Exception {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public void send(Triple item) {
		// TODO Auto-generated method stub
		super.send(item);
	}

}
