package de.dfki.km.academicresearch.eswc2016challenge.pathfinder;

import de.dfki.km.academicresearch.eswc2016challenge.data.Path;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.basis.PathFinder;
import de.dfki.km.academicresearch.eswc2016challenge.util.Util;
import java.io.File;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

public class OraclePathFinder extends PathFinder {

	private Iterator<Object[]> iter;
	private Collection<Object[]> tests;
	private int task;
	public OraclePathFinder(int task, Collection<Object[]> tests) {
		this.tests = tests;		
		this.iter = tests.iterator();
		this.task = task;
	}
	
	
	
	@Override
	public List<Path> find(String srcURI, String dstURI, int k, String startOrEndProp) throws Exception {
		List<Path> pathes = new LinkedList<>();
		if(iter.hasNext() == false)
			return pathes;
		
		Object[] params = iter.next();
		if(params.length != 2)
			return pathes;
		
		//load file
        File f = new File("./challenge_training_result_sets/task"+task+"_q" + params[0] + "_" + params[1] + ".txt");        
        List<Path> ret = Util.getPaths(f);
        return ret;
	}
	
	
	@Override
	public boolean hasIndex() {
		return true; //we dont want the streaming
	}

}
