package de.dfki.km.academicresearch.eswc2016challenge.pathfinder.analyse.kind;

import java.io.StringWriter;

import org.jgrapht.graph.DirectedWeightedPseudograph;

import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.analyse.IAnalyse;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgraphturiedge.base.URIEdge;

public class Summary implements IAnalyse {

	protected long subjectNotURI = 0;
	protected long predicateNotURI = 0;
	protected long objectNotURI = 0;
	protected long totalURITriples = 0;
	
	protected long tripleCount = 0;
	
	
	
	
	public Summary(long subjectNotURI, long predicateNotURI, long objectNotURI, long totalURITriples,
			long tripleCount) {
		this.subjectNotURI = subjectNotURI;
		this.predicateNotURI = predicateNotURI;
		this.objectNotURI = objectNotURI;
		this.totalURITriples = totalURITriples;
		this.tripleCount = tripleCount;
	}

	@Override
	public void sendOnlyURI(String subject, String predicate, String object) {

	}

	@Override
	public String getResult(DirectedWeightedPseudograph<String, URIEdge> g) throws Exception {
		StringWriter w = new StringWriter();
		try{
			w.write(String.format("#Summary:%n"));
			w.write(String.format("#Triple Count:%d %n", tripleCount));
			w.write(String.format("#totalURITriples:%d %n", totalURITriples));
			w.write(String.format("#subjectNotURI:%d %n", subjectNotURI));
			w.write(String.format("#predicateNotURI:%d %n", predicateNotURI));
			w.write(String.format("#objectNotURI:%d %n", objectNotURI));
		}finally{
			w.close();
		}
		return w.toString();
	}

}
