package de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jade;

import de.dfki.km.jade.graph.core.CoreBiGraph;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class GraphIndexJade {

    /**
     * A graph of the jade library with special SPOVertex and SPOEdge.
     */
    private CoreBiGraph<SPOVertex, SPOEdge> graph;
    
    /**
     * A map which maps an ID to the corresponding vertex.
     */
    private Map<String, SPOVertex> id2vert;
    
    public GraphIndexJade() {
        this.graph = new CoreBiGraph<>();
        this.id2vert = new HashMap<>();
    }
    
    public void load(Collection<SPOVertex> v, Collection<SPOEdge> e) {
        graph = new CoreBiGraph<>(v, e);
    }
    
    @Override
    public String toString() {
        return "GraphIndexJade: " + graph.getVertices().size() + " vertices, " + graph.getEdges().size() + " edges";
    }

    public CoreBiGraph<SPOVertex, SPOEdge> getGraph() {
        return graph;
    }

    /**
     * @return the id2vert
     */
    public Map<String, SPOVertex> getId2Vert() {
        return id2vert;
    }

}
