package de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jade;

import de.dfki.km.jade.graph.core.CoreWeightedEdge;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class SPOEdge extends CoreWeightedEdge<SPOVertex> {
    
    private String predicate;
    
    private SPOEdge() {
        
    }
    
    public SPOEdge(SPOVertex s, String predicate, SPOVertex o) {
        super(s, o);
        this.predicate = predicate;
        this.m_weight = 1;
    }
    
    /**
     * @return the predicate
     */
    public String getPredicate() {
        return predicate;
    }

    @Override
    public String toString() {
        return "SPOEdge{" + "subject=" + getSource().getId() + ", predicate=" + predicate + ", object=" + getTarget().getId() + '}';
    }
    
    
    
}
