package de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgrapht;

import de.dfki.km.academicresearch.eswc2016challenge.data.Path;
import java.util.Collections;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.Set;
import org.apache.jena.rdf.model.Resource;
import org.apache.jena.rdf.model.Statement;

/**
 *
 * @author Markus Schr&ouml;der
 */
@Deprecated
public class MarkusV1 extends JGraphTFinderBase {

    @Override
    public List<Path> find(Resource src, Resource dst, int k) throws Exception {

        Queue<StmtPath> next = new LinkedList<>();
        List<StmtPath> found = new LinkedList<>();

        //fist to get the initial pathes
        //initial
        Set<Statement> es = g.outgoingEdgesOf(src);
        for (Statement e : es) {
            StmtPath sp = new StmtPath(e);

            //TODO check endVertex and add to found
            next.add(sp);
        }

        //sort first (bc of big P problem)
        //dont work
        //Collections.sort(next);
        int iter = 0;

        //BFS
        //for each path we go
        while (!next.isEmpty() && found.size() < k) {

            //the path we go currently
            StmtPath cur = next.poll();

            //the end of the path
            //object of last triple
            Resource last = cur.getLast();

            //we look at the branches
            Set<Statement> outs = g.outgoingEdgesOf(last);
            for (Statement e : outs) {

                //no duplicate triples in our current path
                //if we have a duplicate we can not walk this triple
                if (!cur.valid(e)) {

                    //if for all is continue then the path is dead
                    continue;
                }

                //concat the current with the new statement
                StmtPath newPath = new StmtPath(cur, e);

                //if the path ends with the end vertex
                //we are finished
                boolean finished = newPath.getLast().equals(dst);

                if (finished) {
                    //we add to found
                    //and don't search further
                    found.add(newPath);
                } else {
                    //we search for next path
                    next.add(newPath);
                }
            }

            //sort that smaller ones go to top
            //Collections.sort(next);
            //print to see correct result in console
            //print
            System.out.println("Iteration: " + iter++);
            for (StmtPath sp : found) {
                System.out.println(sp.toString());
            }
            System.out.println("----------------------------------------------");
        }

        //sort result
        Collections.sort(found);//StmtPath is Compareable

        //print
        System.out.println("After sort");
        for (StmtPath sp : found) {
            System.out.println(sp.toString());
        }
        System.out.println("----------------------------------------------");

        return translatePath(found);
    }

    private List<Path> translatePath(List<StmtPath> stmtpathes) {

        List<Path> ret = new LinkedList<>();

        for (StmtPath path : stmtpathes) {
            Path newPath = new Path();
            List<Statement> p = path.path;

            if (p.size() > 0) {
                newPath.add(p.get(0).getSubject());
            }
            
            for (Statement e : p) {
                newPath.add(e.getPredicate());
                newPath.add(e.getObject().asResource());
            }
            ret.add(newPath);
        }
        
        return ret;
    }

    private class StmtPath implements Comparable<StmtPath> {

        public Set<Statement> set;
        public List<Statement> path;

        public StmtPath() {
            this.set = new HashSet<>();
            this.path = new LinkedList<>();
        }

        public StmtPath(Statement stmt) {
            this.set = new HashSet<>();
            this.path = new LinkedList<>();
            set.add(stmt);
            path.add(stmt);
        }

        public StmtPath(StmtPath path, Statement newStmt) {
            this.set = new HashSet<>(path.set);
            this.path = new LinkedList<>(path.path);
            this.set.add(newStmt);
            this.path.add(newStmt);
        }

        public boolean valid(Statement newStmt) {
            return !set.contains(newStmt);
        }

        public Resource getLast() {
            if (path.isEmpty()) {
                return null;
            }

            return path.get(path.size() - 1).getObject().asResource();
        }

        @Override
        public String toString() {
            StringBuilder sb = new StringBuilder();

            sb.append("(");
            sb.append(path.size());
            sb.append(") ");

            for (Statement stmt : path) {
                sb.append(stmt.toString());
            }

            return sb.toString();
        }

        @Override
        public int compareTo(StmtPath other) {
            if (this.path.size() > other.path.size()) {
                return 1;
            }
            if (this.path.size() < other.path.size()) {
                return -1;
            }

            //first comes: P
            String firstPred1 = this.path.get(0).getPredicate().toString();
            String firstPred2 = other.path.get(0).getPredicate().toString();
            return firstPred1.compareTo(firstPred2);
        }

    }

}
