package de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgraphturiedge;

import de.dfki.km.academicresearch.eswc2016challenge.data.Path;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.basis.URIPathFinder;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgraphturiedge.base.JGraphTFinderBaseURI;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgraphturiedge.base.URIEdge;

import java.util.List;

import org.jgrapht.DirectedGraph;
import org.jgrapht.GraphPath;
import org.jgrapht.alg.KShortestPaths;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class JGraphtKShortest extends JGraphTFinderBaseURI {

    private static final Logger logger = LoggerFactory.getLogger(JGraphtKShortest.class);

    public JGraphtKShortest() {
    }

    //Problem here is simple path:
    //In graph theory a simple path is a path in a graph which does not have repeating vertices. See path (graph theory).
    //https://en.wikipedia.org/wiki/Simple_path
    //eppstein isn't in jgrapht
    //https://github.com/jgrapht/jgrapht/issues/131
    //but we need: ... path is a path in a graph which does not have repeating edges.
    @Override
    public List<Path> find(String srcURI, String dstURI, int k, String startOrEndProp) throws Exception {

        KShortestPaths<String, URIEdge> sp = new KShortestPaths<String, URIEdge>(g, srcURI, k);

        List<GraphPath<String, URIEdge>> pathes = sp.getPaths(dstURI);

        List<Path> ourPath = JGraphTUtil.translatePath(pathes);

        return null;
    }
}
