package de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgraphturiedge.export;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.jgrapht.ext.DOTExporter;
import org.jgrapht.graph.DefaultWeightedEdge;
import org.jgrapht.graph.DirectedWeightedPseudograph;

import de.dfki.km.academicresearch.eswc2016challenge.data.Path;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgraphturiedge.base.JGraphTFinderBaseURI;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgraphturiedge.base.URIEdge;

public class EppsteinFileExporter extends JGraphTFinderBaseURI{


	private Map<String, Integer> map;
	
	public EppsteinFileExporter() {
		this.map = new HashMap();
	}
	
	@Override
	public List<Path> find(String srcURI, String dstURI, int k, String startOrEndProp) throws Exception {		
		return null;
	}
	
	@Override
	protected String getIndexExtension() {
		return ".gr";
	}
	
	
	@Override
	public void endStreaming() throws Exception {
		super.endStreaming();		
		export(this.g);		
	}

	private static final String newline = System.getProperty("line.separator");
	
	private void export(DirectedWeightedPseudograph<String, URIEdge> g) throws IOException{
		int counter = 1;
		for(String uri : g.vertexSet()){
			if(map.containsKey(uri)==false){
				map.put(uri, counter);
				counter++;
			}
		}		
		
		Set<URIEdge> newset = new HashSet();
		Set<String> srcdst = new HashSet();
		for(URIEdge e : g.edgeSet()){
			String t = e.getSource()+e.getTarget();
			
        	if(e.getSource().equals(e.getTarget())==false){ //reflexive
        		if(srcdst.contains(t)==false){ //multiedge
	        		newset.add(e);  
	        		srcdst.add(t);
        		}
        	}        			
        }
		
		
        
        FileWriter fw = new FileWriter(this.getIndexFile());
        fw.write("n " + g.vertexSet().size() + newline); //number of nodes
        fw.write("m " + newset.size() + newline); //number of edges
        //fw.write("s " + 0 + newline); //start
        //fw.write("t " + 1 + newline); //end
        
        fw.write("s " + map.get("http://dbpedia.org/resource/Felipe_Massa") + newline); //start
        fw.write("t " + map.get("http://dbpedia.org/resource/Red_Bull") + newline); //end
        
        for(URIEdge e : newset){
        	if(e.getSource().equals(e.getTarget())==false)
        		fw.write("a " + map.get(e.getSource()) + " " +map.get(e.getTarget()) + " 1" + newline); //end        	
        }
        fw.close();
	}
}
