package de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgraphturiedge.export;

import java.io.FileWriter;
import java.io.IOException;
import java.util.List;

import javax.xml.transform.TransformerConfigurationException;

import org.jgrapht.ext.DOTExporter;
import org.jgrapht.ext.EdgeNameProvider;
import org.jgrapht.ext.GraphMLExporter;
import org.jgrapht.ext.VertexNameProvider;
import org.jgrapht.graph.DirectedWeightedPseudograph;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.xml.sax.SAXException;

import de.dfki.km.academicresearch.eswc2016challenge.data.Path;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgraphturiedge.base.JGraphTFinderBaseURI;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgraphturiedge.base.URIEdge;

public class GraphML extends JGraphTFinderBaseURI{

	private static final Logger logger = LoggerFactory.getLogger(GraphML.class);
	
	@Override
	public List<Path> find(String srcURI, String dstURI, int k, String startOrEndProp) throws Exception {
		// TODO Auto-generated method stub
		return null;
	}
	
	
	@Override
	public void endStreaming() throws Exception {
		super.endStreaming();		
		export(this.g);		
	}
	@Override
	protected String getIndexExtension() {
		return ".graphml";
	}

	
	protected void export(DirectedWeightedPseudograph<String, URIEdge> g) throws IOException{
		
		
		CopiedGraphMLExporter<String, URIEdge> exp = new CopiedGraphMLExporter<String, URIEdge>(
				(String v) -> v,
				(String v) -> v,
				new EdgeNameProvider<URIEdge>() {
					@Override
					public String getEdgeName(URIEdge edge) {
						//return edge id
						return edge.getIdentificationString();
					}},
				new EdgeNameProvider<URIEdge>() {
					@Override
					public String getEdgeName(URIEdge edge) {
						//return edge label
						//return edge.getEdgeLocalName();
						return edge.getEdge();//full uri of edge
						//return edge.getIdentificationString();//source, edge and target in one string
					}}
				
				);
		
		FileWriter fw = new FileWriter(this.getIndexFile());
		try {
			exp.export(fw, g);
		} catch (TransformerConfigurationException | SAXException e) {
			logger.error("Export GraphML", e);
		}
        fw.close();
		
		
	}

}
