package de.dfki.km.academicresearch.eswc2016challenge.pathfinder.subsetExtractor;

import de.dfki.km.academicresearch.eswc2016challenge.data.Path;
import de.dfki.km.academicresearch.eswc2016challenge.data.PathList;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.basis.PathFinder;
import java.io.File;
import java.io.FileOutputStream;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import org.apache.jena.graph.Triple;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.rdf.model.Resource;
import org.apache.jena.riot.RDFDataMgr;
import org.apache.jena.riot.RDFFormat;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class SubsetExtractor extends PathFinder {

    private static final Logger logger = LoggerFactory.getLogger(SubsetExtractor.class);

    private Set<Resource> allPathResources;
    private Set<String> allPathResourcesString;
    private List<Path> listExpected;
    private Model m;
    private File subsetStorage;

    public SubsetExtractor(int query, int k, File subsetStorage) {
        this.subsetStorage = subsetStorage;
        File f = new File("./challenge_training_result_sets/task1_q" + query + "_" + k + ".txt");
        try {
            listExpected = PathList.toPathList(f);
        } catch (Exception e) {
            logger.error("PAthList error", e);
        }

        allPathResources = new HashSet<>();
        allPathResourcesString = new HashSet<>();

        for (Path p : listExpected) {
            allPathResources.addAll(p.getPath());
            for (Resource r : p.getPath()) {
                if (r.isURIResource()) {
                    allPathResourcesString.add(r.getURI());
                }
            }
        }

        m = ModelFactory.createDefaultModel();
    }

    @Override
    public List<Path> find(String srcURI, String dstURI, int k, String startOrEndProp) throws Exception {
        return null;
    }

    int subject = 0;
    int predicate = 0;
    int object = 0;

    @Override
    public void send(Triple item) {
        //super.send(item);

        if (item.getSubject().isURI()) {
            if (allPathResourcesString.contains(item.getSubject().getURI())) {
                m.add(m.asStatement(item));
                subject++;
            }
        }

        /*
		if(item.getPredicate().isURI()){
			if(allPathResourcesString.contains(item.getPredicate().getURI())){
				m.add(m.asStatement(item));
				predicate++;
			}
		}
         */
        if (item.getObject().isURI()) {
            if (allPathResourcesString.contains(item.getObject().getURI())) {
                m.add(m.asStatement(item));
                object++;
            }
        }

        /*
		if(allPathResources.contains(item.getSubject()))	{
			m.add(m.asStatement(item));
			subject++;
		}
				
		
		if(allPathResources.contains(item.getPredicate()))	{
			m.add(m.asStatement(item));
			predicate++;
		}
			
		
		if(allPathResources.contains(item.getObject()))		{
			m.add(m.asStatement(item));
			object++;
		}
         */
    }

    @Override
    public void endStreaming() throws Exception {
        super.endStreaming();

        //m.write(new FileWriter(subsetStorage),
        RDFDataMgr.write(new FileOutputStream(subsetStorage), m, RDFFormat.NTRIPLES_UTF8);

    }

}
