package de.dfki.km.academicresearch.eswc2016challenge.sink;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import org.apache.jena.atlas.lib.Sink;
import org.apache.jena.graph.Triple;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class ArraySink implements Sink<Triple> {

    private static final Logger logger = LoggerFactory.getLogger(ArraySink.class);
    
    private String[] data;
    private int index;
    
    public ArraySink(int length) {
        data = new String[length];
        index = 0;
    }
    
    @Override
    public void send(Triple t) {
        if(t.getObject().isLiteral())
            return;
        
        data[index] = t.getSubject().getURI();
        index++;
        
        data[index] = t.getPredicate().getURI();
        index++;
        
        data[index] = t.getObject().getURI();
        index++;
    }

    @Override
    public void flush() {
        logger.debug("flush");
    }

    @Override
    public void close() {
        logger.debug("close, serialize to file");
        
        ObjectOutputStream out = null;
        try {
            out = new ObjectOutputStream(new FileOutputStream("training_dataset_filtered.bin"));
            out.writeObject(data);
            out.close();
        } catch (IOException ex) {
            logger.error(null, ex);
        } finally {
            try {
                out.close();
            } catch (IOException ex) {
                logger.error(null, ex);
            }
        }
        
        logger.debug("done");
    }
    
    //needs Total time: 36.873s for loading and serialization
    //training_dataset_filtered.bin has 359MB
    
}
