package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset;

import java.io.Closeable;
import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.jena.graph.Node;
import org.apache.jena.query.text.Entity;
import org.apache.jena.query.text.EntityDefinition;
import org.apache.jena.query.text.TextHit;

import de.dfki.km.academicresearch.eswc2016challenge.data.Path;

public interface GraphIndex extends Closeable{

	// Transactional operations
    void prepareCommit() ;
    void commit() ;
    void rollback() ;
    
    
    // Update operations
    public void add(Node g, Node s, Node p, Node o);
	public void remove(Node g, Node s, Node p, Node o);
    
    /** Access the index
     */ 
	List<Path> find(String srcURI, String dstURI, int k, String startOrEndProp) throws Exception;
	
	/** Access the index
     */ 
	Iterator<? extends Path> find(String srcURI, String dstURI, String startOrEndProp) throws Exception;
	
	@Override
	public void close();

}
