package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset;

import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.List;

import org.apache.jena.graph.Node;
import org.apache.jena.graph.Triple;

import de.dfki.km.academicresearch.eswc2016challenge.data.Path;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.basis.PathFinder;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgraphturiedge.EppsteinV2;
import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.jgraphturiedge.MarkusV2;

public class PathFinderGraphIndex implements GraphIndex{

	private File f; 
	private PathFinder finder;
	
	public PathFinderGraphIndex(File f) {
		this.f = f;
		this.finder = new MarkusV2();//new EppsteinV2();
		try {
			this.finder.startStreaming();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	@Override
	public void prepareCommit() {}
	@Override
	public void commit() {}
	@Override
	public void rollback() {}

	@Override
	public void add(Node g, Node s, Node p, Node o) {
		this.finder.send(new Triple(s, p, o));
	}

	@Override
	public void remove(Node g, Node s, Node p, Node o) {}

	@Override
	public List<Path> find(String srcURI, String dstURI, int k, String startOrEndProp) throws Exception {
		return finder.find(srcURI, dstURI, k, startOrEndProp);
	}

	@Override
	public void close() {}


	@Override
	public Iterator<? extends Path> find(String srcURI, String dstURI, String startOrEndProp) throws Exception {
		return finder.find(srcURI, dstURI, startOrEndProp);
	}

}
