package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset.assembler;



import org.apache.jena.assembler.Assembler;
import org.apache.jena.assembler.Mode;
import org.apache.jena.assembler.assemblers.AssemblerBase;
import org.apache.jena.query.Dataset;
import org.apache.jena.rdf.model.Resource;
import org.apache.jena.sparql.core.assembler.DatasetAssembler;
import org.apache.jena.sparql.util.graph.GraphUtils;

import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset.GraphDatasetFactory;
import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset.GraphIndex;

public class GraphDatasetAssembler extends AssemblerBase implements Assembler {

	private DatasetAssembler datasetAssembler = new DatasetAssembler() ;

    public static Resource getType() { return GraphVocab.graphDataset ; }

    /*
:graph_dataset rdf:type     graph:GraphDataset ;
graph:dataset   <#dataset> ;
graph:index     <#graphIndex> ;
.

     */

    @Override
    public Dataset open(Assembler a, Resource root, Mode mode)
    {
        Resource dataset = GraphUtils.getResourceValue(root, GraphVocab.pDataset) ;
        Resource index   = GraphUtils.getResourceValue(root, GraphVocab.pIndex) ;

        Dataset ds = (Dataset)a.open(dataset) ;
        GraphIndex graphIndex = (GraphIndex)a.open(index) ;
        
        Dataset dst = GraphDatasetFactory.create(ds, graphIndex, true) ;
        return dst ;
    }
}
