package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset.assembler;


import java.io.File;

import org.apache.jena.assembler.Assembler;
import org.apache.jena.assembler.Mode;
import org.apache.jena.assembler.assemblers.AssemblerBase;
import org.apache.jena.atlas.lib.IRILib;
import org.apache.jena.query.text.TextIndexException;
import org.apache.jena.rdf.model.RDFNode;
import org.apache.jena.rdf.model.Resource;
import org.apache.jena.sparql.util.graph.GraphUtils;
import org.apache.lucene.store.Directory;

import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset.GraphDatasetFactory;
import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset.GraphIndex;

public class GraphIndexAssembler extends AssemblerBase implements Assembler {

	/*
# Graph index description
<#graphIndex> a graph:GraphIndex ;
graph:directory <file:Graph> ;
#graph:directory "mem".
	 */
	
	@Override
	public GraphIndex open(Assembler a, Resource root, Mode mode) {
		if ( !GraphUtils.exactlyOneProperty(root, GraphVocab.pDirectory) )
		    throw new TextIndexException("No 'graph:directory' property on " + root) ;

		Directory directory ;
		
		RDFNode n = root.getProperty(GraphVocab.pDirectory).getObject() ;
		
		File dir = null;
		if ( n.isLiteral() ) {
		    String literalValue = n.asLiteral().getLexicalForm() ; 
		    /*
		    if (literalValue.equals("mem")) {
		        directory = new RAMDirectory() ;
		    } else {
		        File dir = new File(literalValue) ;
		        directory = FSDirectory.open(dir) ;
		    }
		    */
		    
		    dir = new File(literalValue) ;
		    
		} else {
		    Resource x = n.asResource() ;
		    String path = IRILib.IRIToFilename(x.getURI()) ;
		    dir = new File(path) ;
		}
		return GraphDatasetFactory.createGraphIndex(dir) ;
	}

	


}
