package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.describe;

import java.io.File;
import java.util.List;

import org.apache.jena.atlas.lib.StrUtils;
import org.apache.jena.query.Dataset;
import org.apache.jena.query.DatasetFactory;
import org.apache.jena.query.QueryExecution;
import org.apache.jena.query.QueryExecutionFactory;
import org.apache.jena.query.ReadWrite;
import org.apache.jena.query.ResultSet;
import org.apache.jena.query.ResultSetFormatter;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.riot.RDFDataMgr;
import org.apache.jena.sparql.engine.QueryEngineFactory;
import org.apache.jena.sparql.engine.QueryEngineRegistry;

import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset.GraphDatasetFactory;
import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.ownengine.HiconEngine;
import de.dfki.km.academicresearch.eswc2016challenge.util.ExampleDataset;

public class DescribeMain {

	public static void main(String[] args) {

		String query = StrUtils.strjoinNL
                ( "PREFIX dbr: <http://dbpedia.org/resource/>"
                , "PREFIX : <http://doesnotexist.org>"
                , "DESCRIBE *"
                , "WHERE  { dbr:Felipe_Massa !:* dbr:Red_Bull. }"
                //, "LIMIT 10"
                ) ;
		
		HiconEngine.register();
       //QueryEngineRef.register();
		
		String task = String.format("task1_q%s_%s", 1, 8); //query, k
		Dataset ds = GraphDatasetFactory.createGraphIndex(DatasetFactory.create(), new File("/.testgraph/"));		
		ds.begin(ReadWrite.WRITE) ;
        try {
            Model m = ds.getDefaultModel() ;
            RDFDataMgr.read(m, String.format("./subset/%s.nt",task)) ;
            ds.commit() ;
        } finally { ds.end() ; }
		 
       QueryExecution qe = QueryExecutionFactory.create(query, ds);//here also the additional variables are added (for *)//QueryExecutionFactory.create(query, infmodel);
       Model response =  qe.execDescribe();
       response.write(System.out);
       qe.close();

	}

}
