package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.fuseki;

import java.nio.file.Paths;

import org.apache.jena.atlas.lib.FileOps;
import org.apache.jena.fuseki.cmd.FusekiCmd;
import org.apache.jena.fuseki.jetty.JettyFuseki;
import org.apache.jena.fuseki.server.FusekiServerListener;
import org.apache.jena.query.ARQ;
import org.apache.jena.sparql.engine.main.QC;

import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.opExecutor.HiconOpExecutorFactory;

public class FusekiMain {
	
	public static void main(String[] args) {
		
		/*
		FusekiServerListener.initialSetup = cmdLineConfig ;
        // For standalone, command line use ...
        JettyFuseki.initializeServer(jettyServerConfig) ;
        JettyFuseki.instance.start() ;
        JettyFuseki.instance.join() ;
        System.exit(0) ;
        */
		
		//http://mail-archives.apache.org/mod_mbox/jena-users/201508.mbox/<55C877C6.60803@apache.org>
		
		/*

PREFIX dbr: <http://dbpedia.org/resource/>
PREFIX : <http://doesnotexist.org>
SELECT ?length ?r1 ?r2 ?r3 ?r4 ?r5 ?r6 ?r7 ?r8 ?r9 ?r10 ?r11 ?r12 ?r13 ?r14 ?r15 ?r16 ?r17 ?r18 ?r19 ?r20
WHERE  { dbr:Felipe_Massa !:* dbr:Red_Bull. }
		 
		 */
		//QC.setFactory(ARQ.getContext(), new HiconOpExecutorFactory()) ;
		
		System.setProperty("FUSEKI_HOME", "C:/Software/fuseki/apache-jena-fuseki-2.3.1/") ;
		String fusekiBase = "./fusekibase/" ;
		System.setProperty("FUSEKI_BASE", fusekiBase) ;
		String runArea = Paths.get(fusekiBase).toAbsolutePath().toString() ;
		FileOps.ensureDir(runArea) ;
		
		FusekiCmd.main(
           "--conf=C:/dev/academicresearch/eswc2016challenge/source/config.ttl"
           //"--update", "--loc=DB",  "/ds"
           //"--set=tdb:unionDefaultGraph=true", "/ds"
			//"--mem","/test"
         ) ;
		
		//https://jena.apache.org/documentation/query/text-query.html#text-dataset-assembler
		
		
		//TODO: provide a JAR file which has all the graph additions so that every fuseki server can be also a graph server :-)
		
		//https://jena.apache.org/documentation/query/text-query.html#working-with-fuseki
		//TODO: where do we get the updates and where do we have the dataset
		//https://github.com/apache/jena/blob/72f6e814e17c577160fedc8f2d2f6a4d83943328/jena-text/src/main/java/jena/textindexer.java
		
		//https://github.com/apache/jena/blob/master/jena-text/src/main/java/org/apache/jena/query/text/TextIndex.java
		//https://github.com/apache/jena/blob/master/jena-text/src/main/java/org/apache/jena/query/text/TextQuery.java
		//https://github.com/apache/jena/blob/master/jena-text/src/main/java/org/apache/jena/query/text/TextQueryPF.java
		
		//https://gist.github.com/lawlesst/ba32ad4fcc830b32823a
		
		//http://mail-archives.apache.org/mod_mbox/jena-users/201308.mbox/<06AEB7DE-72C2-4D15-BA61-E296966535FB@mac.com>
		//https://www.mail-archive.com/users@jena.apache.org/msg06911.html
		
		
		//https://jena.apache.org/documentation/query/text-query.html#text-dataset-assembler
		//The usual way to describe an index is with a Jena assembler description.
		//Once setup this way, any data added to the text dataset is automatically indexed as well.


	}

}
