package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.opExecutor;

import org.apache.jena.query.ARQ;
import org.apache.jena.sparql.ARQConstants;
import org.apache.jena.sparql.engine.main.OpExecutorFactory;
import org.apache.jena.sparql.util.Context;
import org.apache.jena.sparql.util.Symbol;

import de.dfki.km.academicresearch.eswc2016challenge.pathfinder.basis.PathFinder;

public class GDB {
	
	//http://grepcode.com/file/repo1.maven.org/maven2/com.hp.hpl.jena/arq/2.8.0/com/hp/hpl/jena/query/larq/LARQ.java

	// The symbol used to register the index in the query context
	/** Marker for system symbols */
    public static final String GdbNS = "http://jena.apache.org/ARQ/GDB#" ;
    
    public static final Symbol indexKey          = Symbol.create(GdbNS+"index") ;
    
    
    public static void setIndex(PathFinder test)
    {
    	setIndex(ARQ.getContext(), test);
    }
    
    public static void setIndex(Context context, PathFinder test)
    {
        context.set(GDB.indexKey, test) ;
    }
    
    
    public static PathFinder getIndex()
    { return getIndex(ARQ.getContext()) ; }
     
     public static PathFinder getIndex(Context context)
     { return (PathFinder)context.get(GDB.indexKey) ; }
    
    
    

}
