package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.opExecutor;

import org.apache.jena.sparql.algebra.op.OpPath;
import org.apache.jena.sparql.engine.ExecutionContext;
import org.apache.jena.sparql.engine.QueryIterator;
import org.apache.jena.sparql.engine.iterator.QueryIterPath;
import org.apache.jena.sparql.engine.main.OpExecutor;
import org.apache.jena.sparql.engine.main.OpExecutorFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.ownengine.HiconEngine;

public class HiconOpExecutor extends OpExecutor {
	
	
	private static final Logger logger = LoggerFactory.getLogger(HiconOpExecutor.class);

	protected HiconOpExecutor(ExecutionContext execCxt) {
		super(execCxt);
	}
	
	
	protected QueryIterator execute(OpPath opPath, QueryIterator input) {
		//QueryEngineBase
		logger.debug("Execute Path: {}", opPath.toString() );
        //return new QueryIterPath(opPath.getTriplePath(), input, execCxt) ;
		return new HiconQueryIterPath(opPath.getTriplePath(), input, execCxt) ;
    }
	
	

}

//we habve currently HiconOpExecutorFactory in own file
/*
public static final OpExecutorFactory stdFactory = new OpExecutorFactory() {
    @Override
    public OpExecutor create(ExecutionContext execCxt) {
        return new HiconOpExecutor(execCxt) ;
    }
} ;
*/