package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.opExecutor;

import org.apache.jena.atlas.io.IndentedWriter;
import org.apache.jena.atlas.lib.Lib;
import org.apache.jena.sparql.core.TriplePath;
import org.apache.jena.sparql.core.Var;
import org.apache.jena.sparql.engine.ExecutionContext;
import org.apache.jena.sparql.engine.QueryIterator;
import org.apache.jena.sparql.engine.binding.Binding;
import org.apache.jena.sparql.engine.iterator.QueryIterRepeatApply;
import org.apache.jena.sparql.path.PathLib;
import org.apache.jena.sparql.serializer.SerializationContext;

import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.opExecutor.path.HiconPathLib;

/**
 * Copy of org.apache.jena.sparql.engine.iterator.QueryIterPath
 * @author Sven
 *
 */
public class HiconQueryIterPath extends QueryIterRepeatApply {
	
	private TriplePath triplePath ;
    private Var varSubject = null ;
    private Var varObject = null ;
    

    public HiconQueryIterPath(TriplePath triplePath, QueryIterator input, ExecutionContext context)
    {
        super(input, context) ;
        this.triplePath = triplePath ;
    }

    @Override
    protected QueryIterator nextStage(Binding binding)
    {
        //QueryIterator qIter = PathLib.execTriplePath(binding, triplePath, getExecContext()) ;
    	QueryIterator qIter = HiconPathLib.execTriplePath(binding, triplePath, getExecContext()) ;
        return qIter ; 
    }
    
    @Override
    protected void details(IndentedWriter out, SerializationContext sCxt)
    {
        out.print(Lib.className(this)) ;
        out.println() ;
        out.incIndent() ;
        out.print(triplePath.toString()) ; 
        out.decIndent() ;
    }

}
