package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.opExecutor;

import java.io.File;
import java.util.List;

import org.apache.jena.atlas.lib.StrUtils;
import org.apache.jena.query.ARQ;
import org.apache.jena.query.Dataset;
import org.apache.jena.query.DatasetFactory;
import org.apache.jena.query.Query;
import org.apache.jena.query.QueryExecution;
import org.apache.jena.query.QueryExecutionFactory;
import org.apache.jena.query.QueryFactory;
import org.apache.jena.query.ReadWrite;
import org.apache.jena.query.ResultSet;
import org.apache.jena.query.ResultSetFormatter;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.riot.RDFDataMgr;
import org.apache.jena.sparql.engine.ExecutionContext;
import org.apache.jena.sparql.engine.QueryEngineFactory;
import org.apache.jena.sparql.engine.QueryEngineRegistry;
import org.apache.jena.sparql.engine.QueryIterator;
import org.apache.jena.sparql.engine.main.OpExecutor;
import org.apache.jena.sparql.engine.main.OpExecutorFactory;
import org.apache.jena.sparql.engine.main.QC;
import org.apache.jena.sparql.util.QueryExecUtils;

import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset.GraphDatasetFactory;
import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.ownengine.HiconEngine;
import de.dfki.km.academicresearch.eswc2016challenge.util.ExampleDataset;

public class OpExecutorMain {

	public static void main(String[] args) {
		
		//Also possible to only extend OpBGP is to use Graph matching and a custom StageGenerator 
		
		
		//Here we extend all possible Operation (Op) but actaully we only want to use OpPath
		
		String task = String.format("task1_q%s_%s", 1, 8); //query, k
		
		//HiconEngine.register();
		
		Dataset ds = GraphDatasetFactory.createGraphIndex(DatasetFactory.create(), new File("/.testgraph/"));
		
		ds.begin(ReadWrite.WRITE) ;
        try {
            Model m = ds.getDefaultModel() ;
            RDFDataMgr.read(m, String.format("./subset/%s.nt",task)) ;
            ds.commit() ;
        } finally { ds.end() ; }
		
		
		
		/*
		Model model = ModelFactory.createDefaultModel();
		
		GraphBuilder gb = new GraphBuilder();
		model.register(gb) ;
		
		RDFDataMgr.read(model, String.format("./subset/%s.nt",task)) ;
		gb.endStreaming();
		
		GDB.setIndex(gb.getGraph());

		QC.setFactory(ARQ.getContext(), new HiconOpExecutorFactory()) ; //if we would use  StageBuilder.setGenerator(ARQ.getContext(), myStageGenerator) ; then we would only modify the opBGP (which is basic triple matching)
		*/
        
        
        /*
		String strQuery = 
				 //"PREFIX d1: <http://km.dfki.de/eswc2016challenge/>\r\n" + 
				 //"PREFIX : <http://doesnotexist.org>\r\n" + 
				 //"SELECT *\r\n" + 
				 //"WHERE  { d1:A !:* d1:B. }";
				 //"WHERE  { d1:A !:* ?dst. }";
				
				 "PREFIX dbr: <http://dbpedia.org/resource/>\r\n" + 
				 "PREFIX : <http://doesnotexist.org>\r\n" + 
				 "SELECT *\r\n" + 
				 "WHERE  { dbr:Felipe_Massa !:* dbr:Red_Bull." + // }";
				 "FILTER(?r3 = <http://dbpedia.org/property/before>)}";
				//"LIMIT 10"
					
		//Dataset datasetM = DatasetFactory.create(ExampleDataset.getDataSetD1());
			
		Query query = QueryFactory.create(strQuery) ;
        
        query.addResultVar("length");
		for(int count = 0; count < 20; count++){
			String variableName = "r" + count;
			query.addResultVar(variableName);			
		}
		
		
        try ( QueryExecution qExec = QueryExecutionFactory.create(query, model) ) {
        	qExec.getContext().set(ARQ.optFilterEquality, false) ;
        	
            ResultSet rs = qExec.execSelect() ;
            ResultSetFormatter.out(rs) ;
        }
        */
        
        
        
        String query = StrUtils.strjoinNL
                ( "PREFIX dbr: <http://dbpedia.org/resource/>"
                , "PREFIX : <http://doesnotexist.org>"
                , "SELECT *"
                , "WHERE  { dbr:Felipe_Massa !:* dbr:Red_Bull. }"// }"
                //, "FILTER(?r3 = <http://dbpedia.org/ontology/firstWin>)}"
                , "LIMIT 10"
                //, "OFFSET 5"
                ) ;
        //=> QueryIterSlice -> return only an iterator not a list
            
        ds.begin(ReadWrite.READ) ;
        try {
            Query q = QueryFactory.create(query) ;
            
            
            q.addResultVar("length");
    		for(int count = 0; count < 20; count++){
    			String variableName = "r" + count;
    			q.addResultVar(variableName);			
    		}
            
    		
    		try ( QueryExecution qExec = QueryExecutionFactory.create(q, ds) ) {            	
                ResultSet rs = qExec.execSelect() ;
                ResultSetFormatter.out(rs) ;
            }
        } finally { ds.end() ; }
        
        
        
        
        //use maybe describe
        
        //how to compute the length of a path when no pathes are retieved yet.
        
        
        
        
        
        
        
        
        
        
		
		
		//TODO: sparql over html  -> load test set and make an open sparql endpoint :-)
		//TODO: limit ausprobieren wie es funktioniert
		
		
		//How can we store the additional index:
		
		//FIRST: like LARQ
		//https://jena.apache.org/documentation/larq/
		//just add the index (java object) to the context (globally or locally - which means on query basis)
		//LARQ.setDefaultIndex(index) ;
		//OR
		//QueryExecution qExec = QueryExecutionFactory.create(query, model) ;
		//LARQ.setDefaultIndex(qExec.getContext(), index) ;
		
		//
		
	}
	

}
