package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.opExecutor.path;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.function.Function;

import org.apache.jena.atlas.iterator.Iter;
import org.apache.jena.graph.Graph;
import org.apache.jena.graph.Node;
import org.apache.jena.graph.NodeFactory;
import org.apache.jena.query.Query;
import org.apache.jena.rdf.model.Resource;
import org.apache.jena.sparql.ARQConstants;
import org.apache.jena.sparql.core.DatasetGraph;
import org.apache.jena.sparql.core.Var;
import org.apache.jena.sparql.engine.ExecutionContext;
import org.apache.jena.sparql.engine.QueryIterator;
import org.apache.jena.sparql.engine.binding.Binding;
import org.apache.jena.sparql.engine.binding.BindingFactory;
import org.apache.jena.sparql.engine.binding.BindingMap;
import org.apache.jena.sparql.engine.iterator.QueryIterPlainWrapper;
import org.apache.jena.sparql.util.Context;
import org.apache.jena.sparql.util.NodeFactoryExtra;

import de.dfki.km.academicresearch.eswc2016challenge.data.Path;
import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset.DatasetGraphGraph;
import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset.GraphIndex;
import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.dataset.GraphQuery;
import de.dfki.km.academicresearch.eswc2016challenge.util.Util;

public class OwnExtension {
	
	public static QueryIterator groundedPath(Binding binding, Graph graph, Node subject, org.apache.jena.sparql.path.Path path, Node object,
            ExecutionContext execCxt){

		
		//Context c1 = execCxt.getDataset().getContext();
		//Context c2 = execCxt.getContext();		
		//Query query = (Query) c2.get(ARQConstants.sysCurrentQuery);//http://jena.apache.org/ARQ/system#query
		
		
		
		
		

//TODO: add more here
    	
    	//PathEval.eval only contains subject and path - no object -> everthing is broken down to subjetc and path
    	//PathEval.eval()
    	
    	//PathEvaluator in PathEval thus can only deal with subject and path -> there are multiple implementations (but these are not relevant for us):
    	//new PathEngine1()
    	//PathEngineN
    	//PathEngineSPARQL
		
		GraphIndex graphIndex = getGraphIndex(execCxt);
    	
		List<Path> pathes = new LinkedList<Path>();
		try {
			pathes = graphIndex.find(subject.getURI(), object.getURI(), 8, "");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    	//so we are here now with the information that subject and object is not a variable
    	
    	//PathFinder f = GDB.getIndex(execCxt.getContext());
    	//List<de.dfki.km.academicresearch.eswc2016challenge.data.Path> pathes = new LinkedList<>();
    	//try {
    	//	pathes = f.find(subject.getURI(), object.getURI(), 10, "");
		//} catch (Exception e) {
			// TODO Auto-generated catch block
		//	e.printStackTrace();
		//}
    	
		/*
		int smallestPath = Util.smallestPath(pathes);
    	
		//Expand the query variables:
		Query query = (Query) execCxt.getContext().get(ARQConstants.sysCurrentQuery);

		query.addResultVar("length");
		for(int count = 0; count < smallestPath; count++){
			String variableName = "r" + count;
			query.addResultVar(variableName);			
		}
		*/
		
    	
    	
    	Function<de.dfki.km.academicresearch.eswc2016challenge.data.Path,Binding> converter = 
    			(de.dfki.km.academicresearch.eswc2016challenge.data.Path hit) -> {
			
			BindingMap bmap = BindingFactory.create(binding);
			bmap.add(Var.alloc("length"), NodeFactoryExtra.intToNode(hit.resourceCount()));
			int count = 0;
			for(Resource r : hit.getPath()){				
				String variableName = "r" + count;
				bmap.add(Var.alloc(variableName), NodeFactory.createURI(r.getURI()));	
				count++;
			}
			//bmap.add(sVar, NodeFactory.createLiteral("Test"));
			
			/*
			BindingMap bmap = BindingFactory.create(binding);
			bmap.add(sVar, NodeFactory.createLiteral("Test"));
			
			Var test = Var.alloc("bla");
			bmap.add(test, NodeFactory.createLiteral("Blub"));
			*/
			return bmap;
			
		};
		
		Iterator<Binding> bIter = Iter.map(pathes.iterator(), converter);
        QueryIterator qIter = new QueryIterPlainWrapper(bIter, execCxt);
        return qIter ;
		
	}
	
	
	
	public static QueryIterator groundedPathTwo(Binding binding, Graph graph, Node subject, org.apache.jena.sparql.path.Path path, Node object,
            ExecutionContext execCxt){
		
		GraphIndex graphIndex = getGraphIndex(execCxt);
		
		Iterator<? extends Path> iterator = null;
		try {
			iterator = graphIndex.find(subject.getURI(), object.getURI(), "");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    	Function<Path,Binding> converter = 
    			(Path hit) -> {			
			BindingMap bmap = BindingFactory.create(binding);
			bmap.add(Var.alloc("length"), NodeFactoryExtra.intToNode(hit.resourceCount()));
			int count = 0;
			for(Resource r : hit.getPath()){				
				String variableName = "r" + count;
				bmap.add(Var.alloc(variableName), NodeFactory.createURI(r.getURI()));	
				count++;
			}
			return bmap;			
		};
		
		Iterator<Binding> bIter = Iter.map(iterator, converter);
        QueryIterator qIter = new QueryIterPlainWrapper(bIter, execCxt);
        return qIter ;
	}
	
	
	
	
	
	
	
	
	
	private static GraphIndex getGraphIndex(ExecutionContext execCxt) {
        
		DatasetGraph dsg = execCxt.getDataset() ;
		
        Context c = dsg.getContext() ; 
        
        Object obj = c.get(GraphQuery.graphIndex) ;

        if (obj != null) {
            try {
                return (GraphIndex)obj ;
            } catch (ClassCastException ex) {
                return null;
            }
        }

        if (dsg instanceof DatasetGraphGraph) {
        	DatasetGraphGraph x = (DatasetGraphGraph)dsg ;
            return x.getGraphIndex();
        }
        //log.warn("Failed to find the text index : tried context and as a graph-enabled dataset") ;
        return null ;
    }
}
