package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.ownengine;

import java.util.List;

import org.apache.jena.query.Dataset;
import org.apache.jena.query.DatasetFactory;
import org.apache.jena.query.QueryExecution;
import org.apache.jena.query.QueryExecutionFactory;
import org.apache.jena.query.ResultSet;
import org.apache.jena.query.ResultSetFormatter;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.sparql.engine.QueryEngineFactory;
import org.apache.jena.sparql.engine.QueryEngineRegistry;
import org.apache.jena.sparql.engine.ref.QueryEngineRef;

import de.dfki.km.academicresearch.eswc2016challenge.util.ExampleDataset;

public class OwnEngineMain {

	public static void main(String[] args) {

		//String strQuery = 
		//		 "PREFIX dbr: <http://dbpedia.org/resource/>\r\n" + 
		//         "PREFIX : <http://doesnotexist.org>\r\n" + 
		//         "SELECT *\r\n" + 
		//         "WHERE  { dbr:Felipe_Massa !:* dbr:Red_Bull. }\r\n" + 
		//         "LIMIT 10";
		
		String strQuery = 
				 "PREFIX d1: <http://km.dfki.de/eswc2016challenge/>\r\n" + 
		         "PREFIX : <http://doesnotexist.org>\r\n" + 
		         "SELECT *\r\n" + 
		         //"WHERE  { d1:A !:* d1:B. }";
		         "WHERE  { d1:A !:* ?dst. }";
		
		HiconEngine.register();
        //QueryEngineRef.register();
		
        List<QueryEngineFactory> possibleFactories = QueryEngineRegistry.get().factories();
		
		 Model m = ExampleDataset.getDataSetD1();
		 
		 Dataset datasetM = DatasetFactory.create(m);
		
		 //query.addResultVar("bla");//here we can add arbirtary new values :-)
		 //query.addResultVar("?test");
		 
        QueryExecution qe = QueryExecutionFactory.create(strQuery, datasetM);//here also the additional variables are added (for *)//QueryExecutionFactory.create(query, infmodel);
        ResultSet response =  qe.execSelect();
        ResultSetFormatter.out(System.out, response) ;
        qe.close();

	}

}
