package de.dfki.km.academicresearch.eswc2016challenge.sparqlext.propertyfunc;

import org.apache.jena.graph.NodeFactory;
import org.apache.jena.query.ARQ;
import org.apache.jena.query.Query;
import org.apache.jena.query.QueryExecution;
import org.apache.jena.query.QueryExecutionFactory;
import org.apache.jena.query.QueryFactory;
import org.apache.jena.query.ResultSet;
import org.apache.jena.query.ResultSetFormatter;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.Resource;
import org.apache.jena.sparql.core.Var;
import org.apache.jena.sparql.pfunction.PropertyFunctionRegistry;

import de.dfki.km.academicresearch.eswc2016challenge.sparqlext.propertyfunc.test.labelSearch;
import de.dfki.km.academicresearch.eswc2016challenge.util.ExampleDataset;

public class PathSearchMain {
	
	public static void main(String[] args) {
		
		////index: https://jena.apache.org/documentation/larq/
		//https://jena.apache.org/documentation/query/text-query.html
		//https://github.com/apache/jena/blob/master/jena-text/src/main/java/org/apache/jena/query/text/TextQueryPF.java
		
		PropertyFunctionRegistry.get().put("http://km.dfki.de/function#pathSearch", PathSearch.class) ;
		
		Model model = ExampleDataset.getDataSetD1();
		
		String qs = "PREFIX func: <http://km.dfki.de/function#>\r\n"+
					"SELECT * WHERE { [] func:pathSearch (<http://km.dfki.de/eswc2016challenge/A> <http://km.dfki.de/eswc2016challenge/B> 10 \"!:*\"). "+
								"FILTER(?r1 = <http://km.dfki.de/eswc2016challenge/P>) }";
		
        
        Query query = QueryFactory.create(qs) ;
        
        query.addResultVar("length");
		for(int count = 0; count < 20; count++){
			String variableName = "r" + count;
			query.addResultVar(variableName);			
		}
        
        //query.addResultVar("?bla");        
        try ( QueryExecution qExec = QueryExecutionFactory.create(query, model) ) {
        	//Optimize
        	//remove the optimization that 
        	//QueryEngineBase -> line 101
        	//QueryEngineMain -> line 67
        	//Optimize  -> line 202
        	//TransformFilterEquality  -> line 120 and then 329
        	//:
        	// Special case : deduce that the filter will always "eval unbound"
            // hence eliminate all rows. Return the empty table.
        	qExec.getContext().set(ARQ.optFilterEquality, false) ;
        	
            ResultSet rs = qExec.execSelect() ;
            ResultSetFormatter.out(rs) ;
        }
		
	}

}
