package de.dfki.km.academicresearch.eswc2016challenge.util;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class GenerateFilteredDataset {

    public static void createFilteredDatasetTraining() throws FileNotFoundException, IOException {
        createFilteredDataset(new File("training_dataset.nt"), new File("training_dataset_filtered.nt"));
    }

    public static void createFilteredDatasetEval() throws FileNotFoundException, IOException {
        createFilteredDataset(new File("evaluation_dataset.nt"), new File("evaluation_dataset_filtered.nt"));
    }

    private static void createFilteredDataset(File from, File to) throws IOException {
        try (BufferedWriter writer = new BufferedWriter(new FileWriter(to))) {
            try (BufferedReader br = new BufferedReader(new FileReader(from))) {
                String line;
                while ((line = br.readLine()) != null) {
                    writer.write(line.replace("^^<http://dbpedia.org/datatype/brake horsepower>", "") + "\n");
                }
            }
        }
    }

    public static void main(String[] args) {
        try {
            createFilteredDatasetEval();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}
