package de.dfki.km.academicresearch.eswc2016challenge.util;

import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.rdf.model.Property;
import org.apache.jena.rdf.model.Resource;
import org.apache.jena.sparql.vocabulary.FOAF;

/**
 * Vocabulary definitions from file:vocabularies/dublin-core_11.xml
 */
public class MultigraphDataset {
    /** <p>The RDF model that holds the vocabulary terms</p> */
    private static final Model m_model = ModelFactory.createDefaultModel();
    
    /** <p>The namespace of the vocabalary as a string ({@value})</p> */
    public static final String NS = "http://km.dfki.de/eswc2016challengeMultigraph/";
    
    /** <p>The namespace of the vocabalary as a string</p>
     *  @see #NS */
    public static String getURI() {return NS;}
    
    /** <p>The namespace of the vocabalary as a resource</p> */
    public static final Resource NAMESPACE = m_model.createResource( NS );
    
    
    public static final Resource a = m_model.createResource("http://km.dfki.de/eswc2016challengeMultigraph/a");
    public static final Resource b = m_model.createResource("http://km.dfki.de/eswc2016challengeMultigraph/b");
    public static final Resource c = m_model.createResource("http://km.dfki.de/eswc2016challengeMultigraph/c");

    public static final Property a_b_1 = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/a_b_1");
    public static final Property a_b_2 = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/a_b_2");
    public static final Property b_c = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/b_c");
    
    
    public static final Model getDataSet(){
    	
    	Model m = ModelFactory.createDefaultModel();
    	
    	m.add(a, a_b_1, b);
    	m.add(a, a_b_2, b);
    	m.add(b, b_c, c);
    	
    	return m;
    } 
    
}