package de.dfki.km.jade.graph;



/**
 * The general, minimal vertex interface
 * 
 * @author reuschling
 */
public interface Vertex extends Entity
{


    /**
     * Gets the graph index to identify a vertex. We assume an index, in order to offer performant graph access implementations.
     * 
     * @return the index to identify a vertex. We assume this, in order to offer performant graph access implementations
     */
    public int getIndex();



    /**
     * Sets the index to identify a vertex. We assume an index, in order to offer performant graph access implementations<br>
     * <b>Caution :</b> Normally, the index is given from the according graph object this {@link Vertex} comes from / was added to. This method is for
     * convenience in order to create and refer easily graph vertices out of the box on your own, for whatever reason. We assume you know what you do.
     * 
     * @param index the new index
     */
    public void setIndex(int index);


}
