package de.dfki.km.jade.graph.core;



import de.dfki.km.jade.graph.WeightedVertex;



/**
 * A basic {@link WeightedVertex} implementation
 * 
 * @author reuschling
 */
public class CoreWeightedVertex implements WeightedVertex
{

    protected int m_index;

    protected float m_weight = 0;



    @Override
    public void addWeight(float weight2add)
    {
        m_weight += weight2add;
    }



    @Override
    public boolean equals(Object obj)
    {
        if(obj == null) return false;

        CoreWeightedVertex casted = (CoreWeightedVertex) obj;
        return (m_index == casted.m_index) && (m_weight == casted.m_weight);
    }



    @Override
    public int getIndex()
    {
        return m_index;
    }



    @Override
    public float getWeight()
    {
        return m_weight;
    }



    @Override
    public int hashCode()
    {
        return m_index * 31 + Float.floatToIntBits(m_weight);
    }



    @Override
    public void setIndex(int index)
    {
        this.m_index = index;
    }



    @Override
    public void setWeight(float weight)
    {
        m_weight = weight;
    }



    @Override
    public void subtractWeight(float weight2subtract)
    {
        m_weight -= weight2subtract;
    }



    @Override
    public String toString()
    {
        return String.valueOf(m_index) + 'w' + m_weight;
    }

}
