package de.dfki.km.jade.graph.search;



import java.util.Set;

import de.dfki.km.jade.graph.Edge;
import de.dfki.km.jade.graph.Entity;
import de.dfki.km.jade.graph.Vertex;
import de.dfki.km.jade.graph.core.CorePath;



/**
 * The calculated weight directly corresponds to the length of a path, independently to some weights. Thus, using this weight calculator realizes a
 * shortest path algorithm. Filters nothing.
 * 
 * @author reuschling
 * 
 * @param <V> the vertex type
 * @param <E> the edge type
 * @param <R> the result type
 */
public class PathLengthWeightCalculator<V extends Vertex, E extends Edge<V>, R extends Entity> extends WeightCalculator<V, E, R>
{

    @Override
    public float calculateWeight(V newEndVertex, E newEndEdge, CorePath<V, E> parentPath)
    {
        return parentPath.getWeight() + 1;
    }



    @Override
    public boolean filterResult(R potentialResult, Set<R> currentResults)
    {
        // we allow all results
        return false;
    }

}
